SystemOrganization addCategory: #ConfigurationOfDicThesaurusRex!

Object subclass: #ConfigurationOfDicThesaurusRex
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfDicThesaurusRex'!

!ConfigurationOfDicThesaurusRex commentStamp: '<historical>' prior: 0!
Copy me to create a new configuration or edit and evaluate the following doits.

        "Create configuration class and initial baseline method"

        MetacelloToolBox 
                createBaseline: '1.0-baseline'
                for: 'MyProject'
                repository: 'http://www.example.com/MyProjectRepository'
                requiredProjects: #('Gofer')
                packages: #('MyProject-Core' 'MyProject-Tests')
                dependencies:
                        {('MyProject-Core' -> #('Gofer')).
                         ('MyProject-Tests' -> #('MyProject-Core'))}
                groups:
                        {('default' -> #('Core')).
                        ('Core' -> #('MyProject-Core')).
                        ('Tests' -> #('MyProject-Tests'))}.

	   "create initial development method from the baseline"

         MetacelloToolBox
               createDevelopment: '1.0'
               for: 'MyProject'
                importFromBaseline: '1.0-baseline'
                description: 'initial version'.
!

!ConfigurationOfDicThesaurusRex class methodsFor: 'development support' stamp: 'mp 7/29/2013 17:46:25.411'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'private' stamp: 'mp 7/29/2013 17:46:25.42'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'accessing' stamp: 'mp 7/30/2013 11:08:48.203'!
downloadUrl
	^ 'http://www.michaelperscheid.de/tmp/'! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'private' stamp: 'mp 7/29/2013 17:46:25.425'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'private' stamp: 'mp 7/30/2013 10:52:54.842'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemtalksystems.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'metacello tool support' stamp: 'mp 7/29/2013 17:46:25.436'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'loading' stamp: 'mp 7/29/2013 17:46:25.441'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'loading' stamp: 'mp 7/29/2013 17:46:25.445'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'loading' stamp: 'mp 7/29/2013 17:46:25.45'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'accessing' stamp: 'mp 7/29/2013 17:46:25.454'!
project

	^self new project! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'accessing' stamp: 'mp 7/30/2013 11:08:29.358'!
swaUtilities

	^ 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities/'! !

!ConfigurationOfDicThesaurusRex class methodsFor: 'development support' stamp: 'mp 7/29/2013 17:46:25.415'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfDicThesaurusRex methodsFor: 'baselines' stamp: 'mp 8/6/2013 11:39:55.04'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		
		spec project: 'SpellingServices' with: [
			spec
				className: 'ConfigurationOfSpellingServices';
				file: 'ConfigurationOfSpellingServices';
				repository: 'http://www.squeaksource.com/MetacelloRepository';
				versionString: '1.0.1' ].
		
		spec project: 'Widgets' with: [
			spec
				className: 'ConfigurationOfWidgets';
				file: 'ConfigurationOfWidgets';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository';
				versionString: '1.1.4' ].
		
		spec package: 'SwaUtil' with: [spec repository: self class swaUtilities].
		
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'.
		spec 
			package: 'DicThesaurusRex' 
			with: [spec 
					requires: #('SpellingServices' 'Widgets' 'SwaUtil'); 
					preLoadDoIt: #downloadHunspellFiles].
		spec group: 'default' with: #('DicThesaurusRex') ].! !

!ConfigurationOfDicThesaurusRex methodsFor: 'accessing' stamp: 'mp 7/29/2013 17:46:25.308'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfDicThesaurusRex methodsFor: 'symbolic versions' stamp: 'mp 7/29/2013 17:49:31.831'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.! !

!ConfigurationOfDicThesaurusRex methodsFor: 'postload' stamp: 'mp 7/30/2013 11:09:05.958'!
downloadFile: aString binary: aBoolean
	| httpStream |
	httpStream := HTTPClient httpGet: self class downloadUrl, aString.
	aBoolean ifTrue: [httpStream := httpStream binary].
	FileStream 
		fileNamed: aString 
		do: [:stream | stream nextPutAll: httpStream contents].! !

!ConfigurationOfDicThesaurusRex methodsFor: 'postload' stamp: 'mp 7/30/2013 10:31:36.092'!
downloadHunspellFiles
	self 
		downloadFile: 'libhunspell.dll' binary: true;
		downloadFile: 'en_US.aff' binary: false;
		downloadFile: 'en_US.dic' binary: false;
		downloadFile: 'thes_data.dat' binary: false.! !

!ConfigurationOfDicThesaurusRex methodsFor: 'accessing' stamp: 'mp 7/29/2013 17:46:25.406'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfDicThesaurusRex methodsFor: 'symbolic versions' stamp: 'mp 7/29/2013 17:49:37.475'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfDicThesaurusRex methodsFor: 'versions' stamp: 'mp 8/6/2013 11:39:35.433'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Release version for dictionary and thesaurus support in Squeak'.
		spec author: 'mp'.
		spec timestamp: '7/29/2013 18:03'.
		spec 
			project: 'SpellingServices' with: '1.0.1';
			project: 'Widgets' with: '1.1.4'.
		spec 
			package: 'SwaUtil' with: 'SwaUtil-mp.87';
			package: 'DicThesaurusRex' with: 'DicThesaurusRex-mp.132'].! !
